#ifndef _Plane3_H__
#define _Plane3_H__

#include "Vector3.h"

  
/** 3D Plane */
class Plane3 {
public:
  Vector3 mNormal;
  float mD;
  
  Plane3() {}
  
  Plane3(const Vector3 &a,
	 const Vector3 &b,
	 const Vector3 &c
	 ) {
    Vector3 v1=a-b, v2=c-b;
    mNormal = Normalize(CrossProd(v2,v1));
    mD = -DotProd(b, mNormal);

  }

  friend ostream &operator<<(ostream &s, const Plane3 p) {
    s<<p.mNormal<<" "<<p.mD;
    return s;
  }

};
  



#endif
